(************************************************************************)
(* This program is free software; you can redistribute it and/or        *)
(* modify it under the terms of the GNU General Public License as       *)
(* published by the Free Software Foundation; either version 2 of the   *)
(* License, or (at your option) any later version.                      *)
(*                                                                      *)
(* This program is distributed in the hope that it will be useful, but  *)
(* WITHOUT ANY WARRANTY; without even the implied warranty of           *)
(* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU    *)
(* General Public License for more details.                             *)
(*                                                                      *)
(* Written and (c) by Jean-Baptiste Rouquier                            *)
(************************************************************************)
let (+=) ref int = ref := !ref + int
let (|>) x f = f x

let swap array i j =
  let temp = array.(i) in
  array.(i) <- array.(j);
  array.(j) <- temp

let shuffle ?prng array =
  let random_int = match prng with
    | None -> Random.int
    | Some state -> Random.State.int state in
  for i=1 to Array.length array -1 do
    swap array (random_int (succ i)) i
  done

let list_max comparison = function
  | a :: q -> List.fold_left (fun a b -> if comparison a b then a else b) a q
  | [] -> invalid_arg "list_max"
